# -*- coding: utf-8 -*-
from setuphelpers import *
import glob

# registry key(s) where WAPT will find how to remove the application(s)
uninstallkey = []

def install():


    versionsoft = control['version'].split('-',1)[0]
    install_msi_if_needed("seafile-%s-en.msi" % versionsoft,killbefore = ['seaf-daemon','seafile-applet'])
    uninstallkey.remove(get_msi_properties("seafile-%s-en.msi" % versionsoft)['ProductCode'])
    remove_desktop_shortcut('Seafile')

def update_package():
    import re
    index = ensure_unicode(wgets('https://www.seafile.com/en/download/'))
    re_versions = re.compile('download.seadrive.org/seafile-([\d\.]*)-en.msi"')
    # find latest
    last_version = sorted(re_versions.findall(index))[-1]
    print(last_version)
    download_url = 'https://download.seadrive.org/seafile-%s-en.msi' % last_version
    localfile = 'seafile-%s-en.msi' % last_version
    if not isfile(localfile):
        wget(download_url,localfile)

    # recup changelog
    #from BeautifulSoup import BeautifulSoup
    #bs = BeautifulSoup(wgets('https://seacloud.cc/group/3/wiki/client-changelog'))

    # removes old msi
    msis = glob.glob('*.msi')
    for fn in msis:
        if fn != localfile:
            remove_file(fn)

    control = PackageEntry().load_control_from_wapt ('.')
    control.version = '%s-0'% last_version
    control.save_control_to_wapt('.')


def uninstall():
    import time
    try:
        for seafile in installed_softwares('seafile'):
            run(uninstall_cmd(seafile['key']),timeout=20)
    except:
        killalltasks('seafile-applet.exe')
        time.sleep(30)
        if installed_softwares('seafile'):
            error('Error found seafile')


